MMFF/PositionConstraint.h
Go to the documentation of this file.
//
// Copyright (C) 2013 Paolo Tosco
//
// Copyright (C) 2004-2006 Rational Discovery LLC
//
// @@ All Rights Reserved @@
// This file is part of the RDKit.
// The contents are covered by the terms of the BSD license
// which is included in the file license.txt, found at the root
// of the RDKit source tree.
//
#ifndef __RD_MMFFPOSITIONCONSTRAINT_H__
#define __RD_MMFFPOSITIONCONSTRAINT_H__
#include <iostream>
#include <ForceField/Contrib.h>
#include <Geometry/point.h>
namespace ForceFields {
namespace MMFF {
//! A position constraint of the type 0.5k * deltaX^2
class PositionConstraintContrib : public ForceFieldContrib {
public:
PositionConstraintContrib() : d_atIdx(-1){};
//! Constructor
/*!
\param owner pointer to the owning ForceField
\param idx index of the atom in the ForceField's positions
\param minDispl minimum displacement
\param maxDispl maximum displacement
\param forceConst force constant
*/
PositionConstraintContrib(ForceField *owner, unsigned int idx,
double maxDispl, double forceConst);
~PositionConstraintContrib() {}
double getEnergy(double *pos) const;
void getGrad(double *pos, double *grad) const;
virtual PositionConstraintContrib *copy() const {
return new PositionConstraintContrib(*this);
};
private:
int d_atIdx; //!< index of the restrained atom
double d_maxDispl; //!< maximum allowed displacement
RDGeom::Point3D d_pos0; //!< reference position
double d_forceConstant; //!< force constant of the bond
};
}
}
#endif
ForceFields::MMFF::PositionConstraintContrib::PositionConstraintContrib
PositionConstraintContrib()
Definition: MMFF/PositionConstraint.h:24
point.h
ForceFields::MMFF::PositionConstraintContrib::~PositionConstraintContrib
~PositionConstraintContrib()
Definition: MMFF/PositionConstraint.h:37
ForceFields::ForceFieldContrib
abstract base class for contributions to ForceFields
Definition: Contrib.h:17
Contrib.h
ForceFields
Definition: TorsionAngleM6.h:23
ForceFields::MMFF::PositionConstraintContrib::getGrad
void getGrad(double *pos, double *grad) const
calculates our contribution to the gradients of a position
ForceFields::MMFF::PositionConstraintContrib::copy
virtual PositionConstraintContrib * copy() const
return a copy
Definition: MMFF/PositionConstraint.h:41
RDGeom::Point3D
Definition: point.h:45
ForceFields::MMFF::PositionConstraintContrib
A position constraint of the type 0.5k * deltaX^2.
Definition: MMFF/PositionConstraint.h:22
ForceFields::ForceField
A class to store forcefields and handle minimization.
Definition: ForceField.h:56
ForceFields::MMFF::PositionConstraintContrib::getEnergy
double getEnergy(double *pos) const
returns our contribution to the energy of a position